<div class="noi-dung">
    <div class="thanh-dieu-huong">
        <div ng-controller="angular-js-state">
            <h3>Angular JS</h3>
            <ul>
                <li><a href ng-click="angFState1()">1 - Giới thiệu về AngularJS</a></li>
                <li><a href ng-click="angFState2()">2 - Modules và các Controllers</a></li>
                <li><a href ng-click="angFState3()">3 - Đối tượng Scope và rootScope</a></li>
                <li><a href ng-click="angFState4()">4 - Directives và cách dùng</a></li>
                <li><a href ng-click="angFState5()">5 - Binding dữ liệu</a></li>
                <li><a href ng-click="angFState6()">6 - Routing, điều hướng</a></li>
                <li><a href ng-click="angFState7()">7 - Thiết lập sự kiện</a></li>
                <li><a href ng-click="angFState8()">8 - Ứng dụng vào thực tế</a></li>
                <li><a href ng-click="angFState9()">9 - Ưu, nhược điểm</a></li>
                <li><a href ng-click="angFState10()">10 - Lời kết</a></li>
            </ul>
        </div>
        <div>
            <h3>Node JS</h3>
            <ul>
                <li><a href ng-click="nodFState1()">1 - Giới thiệu về NodeJS</a></li>
                <li><a href ng-click="nodFState2()">2 - Các Framework phổ biến</a></li>
                <li><a href ng-click="nodFState3()">3 - Thao tác trên cmd Win32</a></li>
                <li><a href ng-click="nodFState4()">4 - Các Module của NodeJS</a></li>
                <li><a href ng-click="nodFState5()">5 - Callback, Events trong NodeJS</a></li>
                <li><a href ng-click="nodFState6()">6 - Streams, Buffer trong NodeJS</a></li>
                <li><a href ng-click="nodFState7()">7 - HTTP Web Server trong NodeJS</a></li>
                <li><a href ng-click="nodFState8()">8 - Timers, Crawl trong NodeJS</a></li>
                <li><a href ng-click="nodFState9()">9 - Ưu, nhược điểm</a></li>
                <li><a href ng-click="nodFState10()">10 - Lời kết</a></li>
            </ul>
        </div>
        <!-- <div ng-controller="c-sharp-state">
            <h3>C#</h3>
            <ul>
                <li><a href ng-click="cshFState1()">1</a></li>
                <li><a href ng-click="cshFState2()">2</a></li>
                <li><a href ng-click="cshFState3()">3</a></li>
                <li><a href ng-click="cshFState4()">4</a></li>
                <li><a href ng-click="cshFState5()">5</a></li>
                <li><a href ng-click="cshFState6()">6</a></li>
                <li><a href ng-click="cshFState7()">7</a></li>
                <li><a href ng-click="cshFState8()">8</a></li>
                <li><a href ng-click="cshFState9()">9</a></li>
                <li><a href ng-click="cshFState10()">10</a></li>
            </ul>
        </div> -->
    </div>
    <div class="noi-dung-trinh-bay" ng-show="nodState1">
        <h3>Giới thiệu về NodeJS</h3>
        <p class="van-ban">
            <img src="https://lh3.googleusercontent.com/csXm00pBuJvmhsXcI1XauxFGrE66sHBbWI9QyKY0lt2h55a1VaKl6F5TrlH0wBC_aijloKw9lh8a=e14-rj-sc0xffffff-w1270"
                alt="" class="anh-noi-dung">
            &emsp;
            NodeJS là một mã nguồn được xây dựng dựa trên nền tảng Javascript V8 Engine, nó được sử dụng để xây dựng các
            ứng dụng web như các trang video clip, các forum và đặc biệt là trang mạng xã hội phạm vi hẹp. NodeJS là một
            mã nguồn mở được sử dụng rộng bởi hàng ngàn lập trình viên trên toàn thế giới.
            <br>
            <img src="https://jumpcloud.com/wp-content/uploads/2016/07/hi-res-logos.png" alt="" class="anh-noi-dung">
            &emsp;
            NodeJS có thể chạy trên nhiều nền tảng hệ điều hành khác nhau Windows, Linux, OS X. NodeJS cung cấp các thư
            viện phong phú ở dạng Javascript Module khác nhau giúp đơn giản hóa việc lập trình và giảm thời gian ở mức
            thấp nhất.
            <br>
            <img src="https://images.viblo.asia/dab67ecc-1853-4985-b3fb-3483b5eef4c0.png" alt="" class="anh-noi-dung">
            &emsp;
            Đặc trưng phải kể đến của NodeJS là Realtime, là xử lí giao tiếp từ client tới server theo thời gian thực.
            VD: tương tác trên MXH,...

        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="nodState2">
        <h3>Các Framework phổ biến</h3>
        <h4>Express</h4>
        <p class="van-ban">
            <img src="https://funix.edu.vn/wp-content/uploads/2021/09/expressjs-v%C3%A0-nodejs.png" alt=""
                class="anh-noi-dung">
            &emsp;
            ExpressJS là một trong những framework phổ biến dùng để xây dựng API và Website phổ biến nhất của NodeJS. Nó
            được sử dụng rộng rãi đến mức hầu như mọi dự án Web nào đều bắt đầu bằng việc tích hợp Express. Có rất nhiều
            lý
            do để chọn ExpressJS:
        </p>
        <ul class="list-dai">
            <li>Có nhiều tính năng hỗ trợ tất cả những gì bạn cần trong việc xây dựng Web và API</li>
            <li>Quản lý các route dễ dàng</li>
            <li>Cung cấp một nền tảng phát triển cho các API</li>
            <li>Hỗ trợ nhiều thư viện và plugin</li>
            <li>Bảo mật và an toàn hơn so với việc code thuần</li>
            <li>Hỗ trợ cộng đồng tuyệt vời</li>
        </ul>
        <h4>SocketIO</h4>
        <p class="van-ban">
            <img src="https://miro.medium.com/max/638/1*Q5iAbEm4ZuM4RpNlJTI4Hg.jpeg" alt="" class="anh-noi-dung">
            &emsp;
            SocketIO là một web-socket framework có sẵn cho nhiều ngôn ngữ lập trình. Trong NodeJS, SocketIO cho phép
            xây dựng một các ứng dụng realtime như chatbot, tickers, dashboard APIs, và
            nhiều ứng dụng khác.
            <br>
            &emsp;
            SocketIO có lợi ích hơn so với NodeJS thông thường:
        </p>
        <ul class="list-dai">
            <li>Hỗ trợ route URL tùy chỉnh cho web socket</li>
            <li>Tích hợp dễ dàng hơn với Express JS</li>
            <li> Hỗ trợ clustering với Redis</li>
        </ul>
        <p class="van-ban">
            &emsp;
            Ngoài ra còn một số framework khác như:
        </p>
        <ul class="list-dai">
            <li>BodyParser</li>
            <li>ails.JS</li>
            <li>Hapi.JS</li>
            <li>Total.JS</li>
            <li>LoopBack</li>
            <li>Meteor</li>
            <li>Restify</li>
            <li>Koa</li>
        </ul>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="nodState3">
        <h3>Thao tác trên cmd Win32</h3>
        <p class="van-ban">
            &emsp;
            Việc sử dụng NodeJS, chúng ta phải sử dụng ứng dụng một môi trường viết câu lệnh, ở đây, chúng ta sẽ sử dụng
            Windows Command Prompt (cmd Win32).
            <img src="img/NodeJS-cmd-1.png" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Để tạo mới project NodeJS
            <span class="code-center">
                cd C://Users/Username/Documents/NodeJS/Projects/PR01
                npm init
            </span>
            &emsp;
            Và nhập các thông tin theo hướng dẫn.
            <img src="img/NodeJS-cmd-2.png" alt="" class="anh-noi-dung">
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="nodState4">
        <h3>Các Module của NodeJS</h3>
        <p class="van-ban">
            &emsp;
            Xét các modules của NodeJS, ta thấy sự tương đồng với các thư viện JavaScript.
            Thường là một tổ hợp các chức năng được thêm vào ứng dụng của mình.
            <br>
            &emsp;
            Để thêm vào một mô-đun, sử dụng
            <span class="code-center">
                require()
            </span>
            ví dụ:
            <span class="code-center">
                var http = require('http');
            </span>
            và có thể tạo server từ module này:
            <img src="img/nodejs-modules-1.png" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Có thể tự định nghĩa module, ví dụ:
            <img src="img/nodejs-modules-2.png" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Thêm modules đã tạo vào modules chính:
            <img src="img/nodejs-modules-3.png" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Kết quả:
            <img src="img/nodejs-modules-4.png" alt="" class="anh-noi-dung">
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="nodState5">
        <h3>Callback, Events trong NodeJS</h3>
        <p class="van-ban">
            &emsp;
            Khái niệm về callback trong NodeJS cũng tương tự như khái niệm về [callback trong javascript] vì NodeJS sử
            dụng Google V8 JavaScript engine để thực thi mã và phần lớn các module được viết bằng javascript. Các bạn có
            thể hiểu đơn giản rằng callback function được gọi khi đã hoàn thành một tác vụ cụ thể nào đó.
            &emsp;
            Tất cả các API mà NodeJS cung cấp đều được hỗ trợ callback, từ đó giúp NodeJS có khả năng mở rộng cao hơn.
            <img src="https://freetuts.net/upload/tut_post/images/2020/02/24/2184/callback-trong-nodejs.jpg" alt=""
                class="anh-noi-dung">
            <br>
            &emsp;
            Trong một sự án NodeJS, events và callback là 2 khái niệm được sử dụng đồng thời với nhau. Vì một ứng dụng
            viết bằng NodeJS chỉ xử lý đơn luồng bởi thế nó sử dụng hàm async để duy trì đồng thời các hoạt động của nó.
            Node quan sát event loop và sau khi nó được hoàn thành, nó sẽ gọi sự kiện tương ứng để cho các hàm được thực
            thi.
            <img src="https://freetuts.net/upload/tut_post/images/2020/02/24/2186/event-trong-nodejs.jpg" alt=""
                class="anh-noi-dung">
            <br>
            &emsp;
            Khi Node được khởi tạo trên server, đầu tiên nó sẽ khởi tạo các biến, các hàm cần thiết và đợi event xảy ra.
            Nó là lý do tại sao mà NodeJS có thể nhanh hơn các công nghệ khác rất nhiều. NodeJS tạo ra một vòng lặp
            chính để lắng nghe các sự kiện và sau đó nhận lại callback function khi mà sự kiện đó được xác định.
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="nodState6">
        <h3>Streams, Buffer trong NodeJS</h3>
        <p class="van-ban">
            &emsp;
            Streams là một collections của dữ liệu giống như strings hay arrays, sự khác nhau duy nhất đó là các streams
            không tồn tại cùng một lúc do đó không cần chiếm nhiều bộ nhớ.
            <br>
            &emsp;
            Điều khiến streams thực sự mạnh đó là khả
            năng làm việc khi xử lý với dữ liệu lớn (big data) hay nguồn dữ liệu đến từ nguồn bên ngoài một chút một.
            <br>
            &emsp;
            Streams không chỉ dừng lại ở việc xử lý dữ liệu, nó còn đem lại khả năng kết hợp code một cách tuyệt vời,
            giống như khi kết hợp các câu lệnh lunix với nhau thành một câu lệnh duy nhất.
            <br>
            <img src="img/nodejs-stream-1.png" alt="" class="anh-noi-dung">
            <br>
            <img src="img/nodejs-stream-2.png" alt="" class="anh-noi-dung">
            <br>
            <img src="img/nodejs-stream-3.png" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Có rất nhiều các module của NodeJS thực hiện dựa trên hơi hướng của streams như:
            <img src="https://freetuts.net/upload/tut_post/images/2020/02/26/2202/streams-module-nodejs-using-stream.png"
                alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Streams cho phép bạn đọc dữ liệu từ một nguồn hoặc viết dữ liệu đến một đích đến nào đó. Trong NodeJS,
            có 4
            loại streams khác nhau:
        </p>
        <ul class="list-dai">
            <li>Readable: đây là loại streams chỉ dùng để đọc..</li>
            <li>Writable: đây là loại streams chỉ dùng để ghi..</li>
            <li>Duplex: sử dụng cả 2 đọc và ghi.</li>
            <li>Transform: một loại của Duplex nhưng khác nhau bởi kết quả của đầu ra dựa vào đầu vào.</li>
        </ul>
        <p class="van-ban">
            &emsp;
            Mỗi streams đều được cấp một EventEmitter cho phép chúng ta bắt sự kiện theo từng thời điểm cụ thể. Sau đây
            là một vài sự kiện hay dùng:
        </p>
        <ul class="list-dai">
            <li>data: sự kiện này được kích hoạt khi dữ liệu được đọc</li>
            <li>end: sự kiện này được kích hoạt khi không còn dữ liệu để đọc</li>
            <li>error: sự kiện này được kích hoạt khi xảy ra lỗi.</li>
            <li>finish: sự kiện này được kích hoạt khi hoàn thành (dữ liệu đã được đẩy hết về hệ thống cơ sở)</li>
        </ul>
        <p class="van-ban">
            &emsp;
            Để tối ưu việc Streams ở trên với việc xuất file, ta sẽ bàn tới Buffer.
            <br>
            &emsp;
            Javascript thuần sử dụng Unicode khá nhiều, nhưng nó được xây dựng không để hỗ trợ kiểu dữ liệu nhị phân.
            Trong khi xử lý càng luồng TCP hoặc xử lý tệp, cần phải xử lý các luồng octet.
            <br>
            &emsp;
            NodeJs cung cấp cho chúng ta
            Buffer để lưu trữ dữ liệu thô thành các mảng số nguyên tố tương ứng với việc cấp phát bộ nhớ heap V8 (vùng
            nhớ).
            <br>
            &emsp;
            Buffer là một trong những Global Objects Strong Nodejs và nó sẽ được sử dụng mà không cần yêu cầu bất cứ
            module nào.
            <img src="img/nodejs-buffer-1.png" alt="" class="anh-noi-dung">
            <br>
            <img src="img/nodejs-buffer-2.png" alt="" class="anh-noi-dung">
            <br>
            <img src="img/nodejs-buffer-3.png" alt="" class="anh-noi-dung">
            <br>
            <img src="img/nodejs-buffer-4.png" alt="" class="anh-noi-dung">
            <br>
            <img src="img/nodejs-buffer-5.png" alt="" class="anh-noi-dung">
            <br>
            <img src="img/nodejs-buffer-6.png" alt="" class="anh-noi-dung">
            <br>
        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="nodState7">
        <h3>HTTP Web Server trong NodeJS</h3>
        <p class="van-ban">

        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="nodState8">
        <h3>Timers, Crawl trong NodeJS</h3>
        <p class="van-ban">

        </p>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="nodState9">
        <h3>Ưu, nhược điểm</h3>
        <table class="bang-van-ban">
            <thead>
                <tr>
                    <th style="color: rgb(0, 255, 102); font-weight: 700;">Ưu điểm</th>
                    <th style="color: rgb(255, 0, 0); font-weight: 700;">Nhược điểm</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>Có tốc độ xử lý nhanh nhờ cơ chế xử lý bất đồng bộ (non-blocking).</td>
                    <td>Viết bằng C++ và JavaScript nên cần thời gian biên dịch.</td>
                </tr>
                <tr>
                    <td>Dễ dàng mở rộng khi có nhu cầu phát triển website.</td>
                    <td>Chưa phải lựa chọn hàng đầu trong phát triển các dự án quan trọng.
                    </td>
                </tr>
                <tr>
                    <td>Nhận và xử lý nhiều kết nối chỉ với một single-thread. Nhờ đó, hệ thống xử lý sẽ sử dụng ít lượng RAM nhất và giúp quá trình xử Nodejs lý nhanh hơn rất nhiều.</td>
                    <td></td>
                </tr>
                <tr>
                    <td>Có khả năng xử lý nhiều Request/s cùng một lúc trong thời gian ngắn nhất.</td>
                    <td></td>
                </tr>
                <tr>
                    <td>Có khả năng xử lý hàng ngàn Process cho hiệu suất đạt mức tối ưu nhất.</td>
                    <td></td>
                </tr>
                <tr>
                    <td>Phù hợp để xây dựng những ứng dụng thời gian thực như các ứng dụng chat, mạng xã hội,...</td>
                    <td></td>
                </tr>
            </tbody>
        </table>
    </div>
    <div class="noi-dung-trinh-bay" ng-hide="nodState10">
        <h3>Lời kết</h3>
        <p class="van-ban">
            <img src="https://opengraph.githubassets.com/04ccf162f3dd1ae48701cd9784faeacfd632dd25ccd12c8fec1c3841b5cbbd3e/googleapis/google-cloud-node" alt="" class="anh-noi-dung">
            <br>
            &emsp;
            Với sự phổ biến của NodeJS, cơ hội việc làm rất rộng mở. Cộng đồng hỗ trợ lớn mạnh kèm sự đầu tư và phát triển của Google, công nghệ này sẽ có tuổi thọ lâu dài.
        </p>
    </div>
</div>